unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, system.Types, Vcl.ExtDlgs, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Button2: TButton;
    Button3: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure FileOpen(InF : Boolean);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  BaseBM, DrawBM: TBitmap;
  InF  : boolean;
  inpf : byte;

const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

//-----------------------------------------------------------------------------
//  rbg}bv̎w̐F̃At@l0(F)ɂ֐
//  ABitmap    : Ώۂ̃rbg}bvDrbg}bvԂ܂
//  TransColor : ɂF
//  Alpha      : ɂFȊO̓ߗ
//-----------------------------------------------------------------------------
procedure TransparentColorToAlpha(ABitmap: TBitmap; TransColor: TColor; Alpha: Byte);
type
  TRGBQArray = array [0..0] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  R,G,B           : Byte;
  X, Y            : Integer;
  SA              : PRGBQArray;
begin
  ABitmap.Canvas.Lock;        // ̃XbhgpłȂ悤ɂ܂
  ABitmap.AlphaFormat := afIgnored;   // \ς݃oCg͖܂

  //wFR,G,B̊el̎擾
  R := GetRValue(TransColor);
  G := GetGValue(TransColor);
  B := GetBValue(TransColor);

  // ɂF100p[Zg ȊO Alphalɂ܂
  for Y := 0 to ABitmap.Height - 1 do begin
    SA := ABitmap.ScanLine[Y];
    for X := 0 to ABitmap.Width - 1 do begin
      if (R = SA[X].rgbRed) and (G = SA[X].rgbGreen) and (B = SA[X].rgbBlue) then
        SA[X].rgbReserved := 0        // ߗ100p[Zg
      else
        SA[X].rgbReserved := Alpha;   // Alpha 0`255  ߗ100`0
    end;
  end;
  ABitmap.Canvas.Unlock;      // ̃Xbhgp
end;

//-------------------------------------------------
// composition_Bitmap 2̃rbg}bv܂
// X, Y   @@uperBM`悷BaseBM̍W
// Alpha  @@uperBM̕sx
//-------------------------------------------------
procedure composition_Bitmap(NewPic0, BackBM, UperBM: TBitmap; X, Y: integer; Alpha: Byte);
var
  CutBase, CutDraw: TBitmap;          // ҏWprbg}bv
  Rect1, Rect2: TRect;                // lp̈
  Xi, Yi: integer;                    // ߉摜͈͐擪ʒuvZp
  AColor : TColor;
begin
  NewPic0.Assign(BackBM);
  // 摜̎lp`̈
  Rect1 := Rect(0, 0, BackBM.Width, BackBM.Height);
  // ߉摜̗̈ 摜͈͊O
  Rect2 := Rect(X, Y, UperBM.Width + X, UperBM.Height + Y);
  // 摜̉摜̏dȂ͈͌vZ Rect1
  if not IntersectRect(Rect1, Rect1, Rect2) then begin
    ShowMessage('̉摜dȂ镔܂');
    Exit;
  end;
  // NewPic0BackBMrbg}bvC[WRs[
  // ߉摜̏dȂ͈͌vZ Rect2
  Xi := -X;                     // ͈͊O]
  if X >= 0 then Xi := 0;       // XvX̏ꍇ0
  Yi := -Y;                     // ͈͊O]
  if Y >= 0 then Yi := 0;       // YvX̏ꍇ㑤0
  Rect2 := Rect(Xi, Yi, Rect1.Right - X, Rect1.Bottom - Y);

  // ҏWprbg}bv
  CutBase := TBitmap.Create;
  CutDraw := TBitmap.Create;
  // 摜̍
  try
    CutBase.Width       := Rect1.Right  - Rect1.Left;     // 摜̏dȂ镔̔wi摜
    CutBase.Height      := Rect1.Bottom - Rect1.top;      // 摜̏dȂ镔̔wi
    CutBase.PixelFormat := pf32bit;
    CutDraw.Width       := Rect1.Right  - Rect1.Left;     // 摜̏dȂ镔̓߉摜
    CutDraw.Height      := Rect1.Bottom - Rect1.top;      // 摜̏dȂ镔̓߉摜
    CutDraw.PixelFormat := pf32bit;

    // ̃sNZ̐F𓧖FƂ
    AColor := GetPixel(UperBM.Canvas.Handle, 0, UperBM.Height - 1);

    // wi摜dȂ镔̉摜Rs[
    CutBase.Canvas.CopyRect(Rect(0, 0, CutBase.Width, CutBase.Height), Newpic0.Canvas, Rect1);
    // ߉摜dȂ镔̉Rs[
    CutDraw.Canvas.CopyRect(Rect(0, 0, CutDraw.Width, CutDraw.Height), UperBM.Canvas, Rect2);

    // dȂ镔̓߉摜쐬  AlpháA߂̒l@0`255s߁@Delphi2009ȍ~
    TransparentColorToAlpha(CutDraw, AColor, Alpha);

    CutDraw.AlphaFormat := afDefined;    // \oCg̃At@lLɂ܂
    // 摜̏dˍ킹
    CutBase.Canvas.Draw(0, 0, CutDraw);
    // m̏dȂ镔摜̌̕ɃRs[
    NewPic0.Canvas.CopyRect(Rect1, CutBase.Canvas, rect(0, 0,CutBase.Width, CutBase.Height));
  finally
    // ҏWprbg}bv̉
    CutBase.Free;
    CutDraw.Free;
  end;
end;

procedure TForm1.FileOpen(InF : Boolean);
var
  WIC         : TWICImage;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;        // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                  // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                        // TWICImage̐
      try
        WIC.LoadFromFile(OpenPictureDialog1.FileName);// 摜̓ǂݍ
        // ߉摜ǂݍ
        if InF then begin
          DrawBM.Width   := WIC.Width;                // 摜
          DrawBM.Height  := WIC.Height;               // 摜
          DrawBM.Canvas.Draw(0, 0, WIC);              // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
          inpf := inpf or 1;                          // ߉摜ǂݍݍςݐݒ
        end
        // wi摜ǂݍ
        else Begin
          BaseBM.Width  := WIC.Width;                 // 摜
          BaseBM.Height := WIC.Height;                // 摜
          BaseBM.Canvas.Draw(0, 0, WIC);              // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
          image1.Width  := WIC.Width;                 // `Imagegݒ
          image1.Height := WIC.Height;                // wi摜ǂݍݍςݐݒ
          inpf := inpf or 2;
        end;
      finally
        WIC.Free;                                     // TWICImage 
      end;
    end;
  if inpf and 3 = 3 then Button1.Enabled := true;     // 摜Ɠ߉摜ǂݍ܂ꂽ獇{^Cl[u
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  X, Y, A, Ch: integer;
  NewPic: TBitmap;
begin
  val(LabeledEdit1.Text, X, Ch);
  if ch <> 0 then begin
    application.MessageBox('ʒu̒lɊԈႢ܂B','̓~X', 0);
    exit;
  end;
  val(LabeledEdit2.Text, Y, Ch);
  if ch <> 0 then begin
    application.MessageBox('cʒu̒lɊԈႢ܂B','̓~X', 0);
    exit;
  end;
  val(LabeledEdit3.Text, A, Ch);
  if ch <> 0 then begin
    application.MessageBox('ߗ̒lɊԈႢ܂B','̓~X', 0);
    exit;
  end;
  if (A < 0) or (A > 255) then begin
    application.MessageBox('ߗl͈͊OłB','̓~X', 0);
    exit;
  end;
  // 摜̍
  Newpic := TBitmap.Create;
  try
    composition_Bitmap(Newpic, BaseBM, DrawBM, X, Y, A);
    Image1.Canvas.Draw(0, 0, NewPic);
  finally
    NewPic.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  InF := False;       // wi摜ǂݍ݃tO
  FileOpen(InF);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  InF := True;;       // ߉摜ǂݍ݃vO
  FileOpen(InF);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // rbg}bv̉
  BaseBM.Free;
  DrawBM.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // rbg}bv̐
  BaseBM :=TBitmap.Create;
  DrawBM :=TBitmap.Create;
  BaseBM.PixelFormat := pf32bit;
  DrawBM.PixelFormat := pf32bit;
  // 摜ǂݍ݃tONA O[oϐȂ̂ŖĂ
  inpf := 0;
end;

end.
